<template>
    <!-- <md-card-actions class="no-padding"> -->
    <div class="md-layout md-alignment-center-right">
        <div class="md-layout-item md-size-15">
            <slot name="icon"></slot>
        </div>

        <div class="md-layout-item md-size-15">
            <md-badge
                class="md-square color-badge "
                md-position="bottom"
                :md-content="resource.total_resources"
            >
                <md-button
                    class="md-icon-button md-dense  no-margin"
                    @click="ResourcesByCategories(resource)"
                >
                    <md-icon class="text-primary no-padding"
                        >collections</md-icon
                    >
                </md-button>
            </md-badge>
        </div>

        <div class="md-layout-item md-size-15">
            <md-badge
                class="md-square color-badge"
                md-position="bottom"
                :md-content="resource.downloads"
            >
                <md-button
                    class="md-icon-button md-dense no-margin"
                    @click="downloadFile(resource)"
                >
                    <md-icon class="text-primary">get_app</md-icon>
                </md-button>
            </md-badge>
        </div>

        <div class="md-layout-item  md-size-15">
            <md-badge
                class="md-square color-badge"
                md-position="bottom"
                :md-content="resource.shared"
            >
                <md-menu md-size="small" md-align-trigger>
                    <md-button
                        md-menu-trigger
                        class="md-icon-button md-dense no-margin"
                    >
                        <md-icon class="text-primary">share</md-icon>
                    </md-button>

                    <md-menu-content>
                        <li class="social-icon" @click="shareFacebook">
                            <i class="fab fa-facebook fa-lg"></i>
                        </li>
                        <!-- <li class="social-icon" @click="shareTwitter">
                            <i class="fab fa-twitter fa-lg"></i>
                        </li> -->
                        <li
                            class="social-icon"
                            @click="shareWhatsapp(resource.id)"
                        >
                            <i class="fab fa-whatsapp fa-lg"></i>
                        </li>
                    </md-menu-content>
                </md-menu>
            </md-badge>
        </div>
        <div class="md-layout-item  md-size-35">
            <div class="categories">
                <!-- <md-button
                v-for="category in resource.categories"
                v-bind:key="category.id"
                class="md-icon-button md-primary md-raised category "
            >
                {{ category.id }}
            </md-button> -->
                <img
                    v-for="category in resource.categories_info"
                    v-bind:key="category.id"
                    :src="category.icon"
                    width="24"
                    class="img-category"
                />
            </div>
        </div>
    </div>
    <!-- </md-card-actions> -->

    <!-- <div class="md-layout md-alignment-top-right">
            <md-badge class="md-square" md-position="bottom" md-content="38">
                <md-button class="md-icon-button md-dense">
                    <md-icon>collections</md-icon>
                </md-button>
            </md-badge>

            <md-badge class="md-square" md-position="bottom" md-content="05">
                <md-button
                    class="md-icon-button"
                    @click="downloadFile(resource)"
                >
                    <md-icon>get_app</md-icon>
                </md-button>
            </md-badge>

            <md-badge class="md-square" md-position="bottom" md-content="20">
                <md-menu md-size="small" md-align-trigger>
                    <md-button md-menu-trigger class="md-icon-button">
                        <md-icon>share</md-icon>
                    </md-button>

                    <md-menu-content>
                        <li class="social-icon" @click="shareFacebook">
                            <i class="fab fa-facebook fa-lg"></i>
                        </li>
                        <li class="social-icon" @click="shareTwitter">
                            <i class="fab fa-twitter fa-lg"></i>
                        </li>
                        <li class="social-icon" @click="shareWhatsapp">
                                                        <i class="fab fa-whatsapp fa-lg"></i>
                                                    </li> 
                    </md-menu-content>
                </md-menu>
            </md-badge>
            <md-button
                v-for="category in resource.categories"
                v-bind:key="category.id"
                class="md-icon-button md-primary md-raised"
            >

                {{ category }}
            </md-button>
        </div> -->
</template>

<script>
import axios from "axios";

export default {
    name: "MenuRecurso",
    props: ["resource"],
    data() {
        return {
            img: require("../../../assets/img/bg2.jpg"),
            endPoint: "/api/resource",
            // resources: [],
            showRating: false,
            starSize: 20
        };
    },
    computed: {
        user() {
            return this.$auth.watch.data;
        }
    },
    methods: {
        ResourcesByCategories(resource) {
            if(resource.total_resources){
            let categoriesId = [];

            resource.categories_info.forEach(element => {
                categoriesId.push(element.id);
            });
            this.$router.push({
                name: "resources",
                query: { categories: categoriesId }
            });
            }else {
                this.$root.WarnMgs("Sin recursos.");
            }

        },
        downloadFile(resource) {
            if (this.user != null) {
                let current = Object.assign({}, resource);
                let fileName = current.attachment.split("/")[1];
                const uri = `/api/file/${current.id}`;

                axios
                    .get(uri, {
                        responseType: "arraybuffer"
                    })
                    .then(res => {
                        let blob = new Blob([res.data], {
                            type: "application/*"
                        });
                        let link = document.createElement("a");
                        link.href = window.URL.createObjectURL(blob);
                        link.download = fileName;
                        link.click();
                    });
            } else {
                this.$root.WarnMgs("Es necesario iniciar sesión");
            }
        },
        shareFacebook() {
            if (this.user != null) {

                const location = window.location.href;
                const uri = `http://m.facebook.com/sharer.php?u=${location}`;
                window.open(uri, "_blank");
            } else {
                this.$root.WarnMgs("Es necesario iniciar sesión");
            }
        },
        shareTwitter() {
            if (this.user != null) {
                const location = window.location.href;
                const uri = `http://twitter.com/intent/tweet?text=${encodeURIComponent(
                    location
                )}`;
                // const uri = `http://mobile.twitter.com/home?status=${location}`
                window.open(uri, "_blank");
            } else {
                this.$root.WarnMgs("Es necesario iniciar sesión");
            }
        },
        shareWhatsapp(id) {
            if (this.user != null) {
                const location = window.location.origin;
                const uri = `https://api.whatsapp.com/send?text=${encodeURIComponent(
                    location + /app#/
                )}recursos/${id}`;
                window.open(uri, "_blank");
            } else {
                this.$root.WarnMgs("Es necesario iniciar sesión");
            }
        }
    }
};
</script>

<style scoped lang="scss">
.categories {
    float: right;
    .img-category {
        margin-left: 2px;
    }
}
.category {
    width: 25px;
    height: 25px;
    min-width: 20px;
}
.social-icon {
    text-align: center;
    padding: 8px;
}
</style>
